# smart-oil-heating-control-system

## Software
### Design

```mermaid
classDiagram
Inputs <|-- Control
Outputs <|-- Control
Inputs <|-- Safety
Outputs <|-- Safety

Inputs <|-- HTTP_Metrics
Outputs <|-- HTTP_Metrics
Control <|-- HTTP_Metrics
Safety <|-- HTTP_Metrics

    class Inputs{
        +loop()
        +getChamberTemperature()
        +getOutdoorTemperature()
        +getInletFlowTemperature()
        +getReturnFlowTemperature()
    }

    class Outputs{
        +getCirculationPumpState()
        +setCirculationPumpState()
        +getBurnerState()
        +setBurnerState()
    }

    class Control{
        +loop()
        -timetable
    }

    class Safety{
        + loop()
        + setSafeState()
        - checkSensorSanity()
        + getSafetyState()
    }

    class HTTP_Metrics{
        - metrics
        + event_handler()
        + connect_wifi()
        + setMetrics()
    }
```